<template>
  <v-data-iterator v-if="equipmentsRef" :items="equipmentsRef" :items-per-page="10" :search="search">
    <template v-slot:header>
      <v-toolbar class="px-2">
        <v-text-field v-model="search" clearable density="compact" hide-details placeholder="Search"
                      prepend-inner-icon="mdi-magnify" style="max-width: 800px" variant="solo" rounded="xl"
                      class="mx-auto px-1"></v-text-field>
      </v-toolbar>
    </template>

    <template v-slot:default="{ items }">
      <div class="container">
        <div class="incontainer">
          <div class="card d-flex flex-column" v-for="equipment in items" :key="equipment.id">
            <nuxt-link :to="`/equipments/${equipment.raw.id}`">
              <template v-if="equipment.raw.image && equipment.raw.image.length > 0">
                <v-img :src="media + equipment.raw.image[0].url" :aspect-ratio="1" width="150" class="img" cover/>
              </template>
              <template v-else>
                <img src="/assets/image/non-equipment.jpg" :aspect-ratio="1" width="150" class="img" cover/>
              </template>
              <p class="pa-1 mb-auto">{{ equipment.raw.name }}</p>
            </nuxt-link>
            
            <nuxt-link :to="`/equipments/${equipment.raw.id}`" class="mt-auto">
              <p class="pa-1 text-detail">{{ equipment.raw.provider_name }}</p>
              <div class="d-flex text-detail">
                <span class="text-orange-darken-3">ระยะเวลา: {{ equipment.raw.day_limit }} วัน</span>
                <span v-if="equipment.raw.quantity >= 1" class="text-grey-darken-1">เหลือ {{ equipment.raw.quantity }}</span>
                <span v-else class="text-grey-darken-1 mr-2">หมดแล้ว</span>
              </div>
            </nuxt-link>
          </div>
        </div>
      </div>
    </template>

    <template v-slot:footer="{ page, pageCount, prevPage, nextPage }">
      <div class="d-flex align-center justify-center pa-4">
        <v-btn :disabled="page === 1" icon="mdi-arrow-left" density="comfortable" variant="tonal" rounded
               @click="prevPage"></v-btn>

        <div class="mx-2 text-caption">
          Page {{ page }} of {{ pageCount }}
        </div>

        <v-btn :disabled="page >= pageCount" icon="mdi-arrow-right" density="comfortable" variant="tonal" rounded
               @click="nextPage"></v-btn>
      </div>
    </template>
  </v-data-iterator>

  <div v-else>
    <div class="container">
      <div class="incontainer">
          <v-skeleton-loader
            v-for="i in 10" :key="i"
            class="mx-auto border skeleton-loader"
            width="150"
            type="image, article"
          ></v-skeleton-loader>
      </div>
    </div>
  </div>
</template>

<script setup>
useHead({
  title: "Equipment | อุปกรณ์ทั้งหมด",
  meta: [
    {name: "description", content: "อุปกรณ์ทั้งหมด"}
  ]
})
definePageMeta({
  middleware: 'auth',
})

import {ref, onMounted} from 'vue'
import axios from 'axios'

const token = useStrapiToken();
const url = useStrapiUrl();
const media = useStrapiMedia();

const equipments = ref([])
const search = ref('')
const equipmentsRef = ref()

async function getEquipments() {
  try {
    await axios.get(`${url}/users/me`, {
      params: {
        fields: {
          0: 'id'
        },
        populate: {
          department: {
            fields: {
              1: 'id',
            },
            populate: {
              equipments: {
                filters: {
                  quantity: {
                    $gt: 0,
                  }
                },
                fields: {
                  2: 'id',
                  3: 'name',
                  4: 'quantity',
                  5: 'day_limit',
                  6: 'provider_name',
                },
                populate: {
                  image: {
                    fields: {
                      7: 'url',
                    }
                  }
                }
              }
            }
          },
        },
      },
      headers: {
        'Authorization': `Bearer ${token.value}`,
      },
    }).then((response) => {
      equipments.value = [...response.data.department.equipments]
      
      if (equipments.value) {
        equipmentsRef.value = equipments.value.reverse();
        console.log("EquipmentsRef : ", equipmentsRef.value)
      } else {
        equipmentsRef.value = [];
      }
    });
  } catch (error) {
    console.log('Error fetching equipment data:', error)
  }
}

onMounted(getEquipments);
</script>

<style scoped>
@import url(../assets/css/styles/home.css);
</style>
